# (C) Copyright 2008 Brian Fisher, Zach Young, James Paige
# This is Free Software released under the terms of MIT, or GPL, or Apache, or
# something, we haven't made up our minds specificly yet, c'mon! Be patient!
#
# For the Pyweek May 2008 competition: "ROBOTS!"

from locals import *

#------------------------------------------------------------------------------
class EffectStyle(AssetBase):
  animation = AssetRef(AnimationAsset)
  spawn_sound = AssetRef(SoundAsset)

class Effect(object):
  style = AssetRef(EffectStyle)
  
  def __init__(self, baseline_pos, height_offset, effect_style_name):
    self.style = effect_style_name
    self.time_alive = .0
    self.z = baseline_pos.y
    self.pos = baseline_pos + vec2d(0, height_offset)
    self.style.spawn_sound.play()

  def update(self, seconds):
    self.time_alive += seconds
  
  def z_sort_order(self):
    game = HamsterWheel.the_game
    return self.z - game.camera.y

  def is_finished(self):
    return self.time_alive >= self.style.animation.get_length_seconds()

  def draw(self, display):
    game = HamsterWheel.the_game
    frame = self.style.animation.get_image_at_time(self.time_alive)
    display.render(frame, self.pos - game.camera)
   
#------------------------------------------------------------------------------
RegisterAssetExtension(EffectStyle, "effect")

  